Subject: DateTimeConverter's timezone key leads to unexpected behavior
Description

The doc comment of the DateTimeConverter says
 1/** [...]
 2 * By using an array as source you can also override time and timezone of the created DateTime object:
 3 * array(
 4 *  'date' => '<dateString>',
 5 *  'hour' => '<hour>', // integer
 6 *  'minute' => '<minute>', // integer
 7 *  'seconds' => '<seconds>', // integer
 8 *  'timezone' => '<timezone>', // string, see http://www.php.net/manual/timezones.php
 9 * );
10[...]
11

If the timezone is set (given), \DateTime::setTimezone() is called on the already-created object.

But this method modifies the resulting date and time representation. Currently, the DateTime object is created via

$date = \DateTime::createFromFormat($dateFormat, $dateAsString);

So, if the user provided e.g. 15:04:23 and timezone EST (even compare to the html sample @ #27417), the following might happen:

    1. \DateTime::createFromFormat() creates a date representing 15:04:23 CET, because the server's default timezone is CET (e.g.),
    2. timezone EST is set from the source, so ->setTimezone() is invoked, resulting in  modifying the \DateTime object into 11:04:23
EST
    3. but the intended target date should be 15:04:23 EST (compare again the example @ #27417).

My suggestion would be a breaking change that throws overrideTimezoneIfSpecified() away and finds the correct timezone at the

$date = \DateTime::createFromFormat($dateFormat, $dateAsString);

 line. The third argument would then be the time zone.
an additional way could be a workaround that finds out the difference between the current and the intended timezone, applies
->setTimezone() and then ->modify()s the DateTime object with that difference period.

Subtasks:
Bug # 44213: DateTimeConverter's timezone key leads to unexpected behavior Resolved
Related issues:
related to TYPO3.Flow - Feature # 27417: DateTime conversion support Resolved 2011-06-14

Associated revisions
Revision 49196a7c - 2012-07-10 09:46 - Karsten Dambekalns

[BUGFIX] Fix timezone override side effect in DateTimeConverter

Specifying a timezone override in DateTimeConverter would lead to
wrong times due to the timezone being applied to the finished date
instance, not upon creation.

Change-Id: I61cb944052d2372d6e12a051c2c584204b0680d7
Fixes: #35369
Releases: 1.1, 1.2

Revision 195ec432 - 2012-07-13 12:32 - Karsten Dambekalns

[BUGFIX] Fix timezone override side effect in DateTimeConverter

Specifying a timezone override in DateTimeConverter would lead to
wrong times due to the timezone being applied to the finished date
instance, not upon creation.

Change-Id: I61cb944052d2372d6e12a051c2c584204b0680d7
Fixes: #35369
Releases: 1.1, 1.2

History
#1 - 2012-04-03 12:13 - Bastian Waidelich
- Category changed from Validation to Object
- Priority changed from Should have to Must have
- Target version set to 1.1

Good catch! +1 for using the 3rd argument of DateTime::createFromFormat() to solve this. And we should add a unit test that reproduces the error.

#2 - 2012-05-25 09:40 - Karsten Dambekalns
- Target version changed from 1.1 to 1.1 RC1

#3 - 2012-06-25 22:20 - Karsten Dambekalns
- Category changed from Object to Property
- Target version changed from 1.1 RC1 to 1.1
- Affected Flow version changed from Git master to FLOW3 1.0.0

#4 - 2012-07-10 08:53 - Karsten Dambekalns
- Status changed from New to Accepted
- Assigned To set to Karsten Dambekalns

#5 - 2012-07-10 08:58 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12737

#6 - 2012-07-10 09:46 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12737

#7 - 2012-07-12 15:15 - Gerrit Code Review

Patch set 1 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12770

#8 - 2012-07-12 15:35 - Karsten Dambekalns
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:49196a7cf539ce4eafb68e81d79fbfbfd265812a.

#9 - 2012-07-13 12:36 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 2 for branch FLOW3-1.1 has been pushed to the review server.
It is available at http://review.typo3.org/12770

#10 - 2012-07-16 12:35 - Karsten Dambekalns
- Status changed from Under Review to Resolved

Applied in changeset commit:195ec432616c2e790b8d6421c9551b89cdd2fa2b.
